<?php

	function action($pAction,$pArgs = null) {
		$pAction = trim($pAction);
		if ($pAction == "") return false;
		$lReturnValue = null;
		switch ($pAction) {
			case "loadDreambox":
				$lReturnValue = loadDreambox($pArgs);
			break;
			case "zap":
				$lReturnValue = zap($pArgs);
			break;
			case "loadBoutiques":
				$lReturnValue = getBoutiques();
			break;
			case "loadChannels":
				$lReturnValue = getChannels($pArgs);
			break;
			case "serverstatus":
				$lReturnValue = serverStatus();
			break;
			case "killserver":
				$lReturnValue = killServer();
			break;
			case "channelInfo":
				$lReturnValue = getChannelInfo($pArgs);
			break;
			case "tvguide":
				$lReturnValue = showTVGuide($pArgs);
			break;
			case "programinfo":
				$lReturnValue = getProgramInfo($pArgs);
			break;
			case "loadRecordings" :
				$lReturnValue = getRecordings();
			break;
			case "showToolTip":
				$lReturnValue = showToolTip($pArgs);
			break;

			case "start" :
				$lReturnValue = startWatchTime($pArgs);
			break;

			case "stop" :
				$lReturnValue = stopWatchTime($pArgs);
			break;


		}
		return $lReturnValue;
	}

	function stopWatchTime($pChannel) {
		return addWatchLogLine($pChannel,"stop");
	}

	function startWatchTime($pChannel) {
                return addWatchLogLine($pChannel,"start");
        }

	function addWatchLogLine($pChannel,$pAction) {
		$lLogLine = date("d-m-Y H:i:s") . "\t" . mktime() . "\t" . $pAction . "\t" . $_SERVER["REMOTE_ADDR"] . "\t" . session_id() . "\t" . $pChannel . "\n";
                file_put_contents("WatchTime.txt",$lLogLine,FILE_APPEND);
                return new xajaxResponse();

	}


	function loadDreambox($pRenew = 0) {
		$lDreambox = new Dreambox(Settings::getDreamboxIP(),Settings::getEnigmaVersion(),array(Settings::getDreamboxUserName(),Settings::getDreamboxPassword()),$pRenew);

		$lAjaxResponse  = new xajaxResponse();
		if ( ($lMessage = $lDreambox->sanityCheck()) != "") {
			$lAjaxResponse->assign("dialog","innerHTML","<br />Your settup is not correct! Fix the following problems:<br />$lMessage");
			$lAjaxResponse->assign("dialog","style.color","red");
		} elseif ($lDreambox->isOnline()) {
			$lDreambox->loadBoutiques($pRenew);
			$lDreambox->loadChannels($pRenew);
			$lAjaxResponse->script("xajax_action('loadBoutiques');");
			$VLCServerObj = new VLCServer();
			if ($VLCServerObj->getCurrentStream()) {
				$lAjaxResponse->script($VLCServerObj->getJSSettings() . ";");
				$lTV = (substr($VLCServerObj->getCurrentChannel(),-3) != ".ts");

				if ($lTV) $lBoutique = $lDreambox->findBoutiqueWithChannel($VLCServerObj->getCurrentChannel());
				$lAjaxResponse->script("jQuery('#boutiques').val('". ($lTV ? $lBoutique->getID() : "" ) . "');");
				if ($lTV) {
					$lAjaxResponse->script("setTimeout(function(){jQuery('#channels').val('" .$VLCServerObj->getCurrentChannel() . "');xajax_action('tvguide','". $VLCServerObj->getCurrentChannel() . "');},1500);");
					$lAjaxResponse->script("setTimeout(function(){jQuery('#tvguide a:eq(0)').click();},2000);");
				} else {
					$lAjaxResponse->script("xajax_action('loadRecordings','')");
				}
				if ($VLCServerObj->getEmbbedType() == "javascript") {
					$lAjaxResponse->script($VLCServerObj->getEmbeddedPlayer() . ";");
				} else {
					$lAjaxResponse->assign("video1","innerHTML",$VLCServerObj->getEmbeddedPlayer());
				}
			 }
			$lAjaxResponse->script("setTimeout(function(){jQuery('#dialog').dialog('close');},2200);");
		} else {
			$lAjaxResponse->assign("dialog","innerHTML","<br />Your dreambox is <b>OFFLINE</b>! Please power on the dreambox!");
			$lAjaxResponse->assign("dialog","style.color","red");
		}
		$lAjaxResponse->script("setTimeout(function(){ xajax_action('serverstatus',1);},1000);");
		return $lAjaxResponse;
	}


	function getBoutiques() {
		$lDreamBoxObj   = new Dreambox();
		$lDreamBoxObj->resetBoutiqueCounter();

		$lFirstBoutique = "";
		$lReturnValue = "<select name=\"boutiques\" id=\"boutiques\" onchange=\"xajax_action('loadChannels',this.value)\">";
		while ( ($lBoutiqueObj = $lDreamBoxObj->getNextBoutique()) != false ) {
			if ($lFirstBoutique == "") {
				$lFirstBoutique = $lBoutiqueObj->getID();
			}
			$lReturnValue .= "<option value=\"" . $lBoutiqueObj->getID() . "\">" . $lBoutiqueObj->getName() . "</option>\n";
		}
		$lReturnValue .= "</select>\n";

		$lAjaxResponse  = new xajaxResponse();
		$lAjaxResponse->assign("boutiquesSelector","innerHTML",$lReturnValue);
		$lAjaxResponse->script("xajax_action('loadChannels','$lFirstBoutique,1')");
		return $lAjaxResponse;
	}

	function getChannels($pArgs) {
		$pArgs = explode(",",$pArgs);
		$lBoutiqueName = trim($pArgs[0]);
		$lFirst = (isset($pArgs[1]) ? $pArgs[1] : 0);
		$lDreamBoxObj  = new Dreambox();
		$lAjaxResponse = new xajaxResponse();


		$lReturnValue = "<select name=\"channels\" id=\"channels\" onchange=\"xajax_action('tvguide',this.value);\">";
		if ( ($lBoutiqueObj = $lDreamBoxObj->searchBoutique($lBoutiqueName)) != false ) {
			while ( ($lChannelObj = $lBoutiqueObj->getNextChannel()) != false ) {
				$lReturnValue .= "<option value=\"" . $lChannelObj->getID() . "\">" . $lChannelObj->getName() . "</option>\n";
			}
		}
		$lReturnValue .= "</select>\n";
		$lAjaxResponse->assign("channelsSelector","innerHTML",$lReturnValue);
		$lAjaxResponse->script("xajax_action('tvguide',jQuery('#channels :selected').val());");
		return $lAjaxResponse;
	}


	function zap($pArgs) {
		$lVLCObj = new VLCServer(Settings::getEnigmaVersion(),array(Settings::getDreamboxUserName(),Settings::getDreamboxPassword()));
		$lVLCObj->setDimentions($pArgs["resolution"]);
		$lVLCObj->setChannel($pArgs["channels"]);
		$lVLCObj->setAudioCodec($pArgs["audio"]);
		$lVLCObj->setVideoCodec($pArgs["video"]);
		$lVLCObj->setFPS($pArgs["fps"]);
		$lVLCObj->setStreamType($pArgs["transport"]);
		$lVLCObj->setBitrate($pArgs["bitrate"]);
		$lVLCObj->setAudioBitrate("92");
		$lDebug = $lVLCObj->stopServer();
		$lDebug = $lVLCObj->startServer(1);
		$lDreamboxObj = new Dreambox();
		$lDreamboxObj->zap($pArgs["boutiques"],$pArgs["channels"]);
		$lBoutiqueObj = $lDreamboxObj->searchBoutique($pArgs["boutiques"]);
		$lChannelObj = $lBoutiqueObj->getChannel($pArgs["channels"]);
		sleep(3); // Wait for VLC to startup encoding
		foreach ($pArgs as  $lKey => $lValue) {
			$lData .= "$lKey => $lValue\n"; // Debug loop
		}

		$objResponse = new xajaxResponse();
                $objResponse->script("zapClose();");
                if (substr($pArgs["channels"],0,2) == "1:") $objResponse->script("xajax_action('tvguide','". $pArgs["channels"] . "');");
                if (Settings::getDebug()) $objResponse->assign("debug-content","innerHTML","<pre>" . htmlentities($lVLCObj->getEmbeddedPlayer()) . "\n$lDebug\n$lData</pre>");
                $objResponse->script("try { pageTracker._trackPageview(\"dreambox/" . $lChannelObj->getName() . "\"); } catch (e) { }");


		if ($pArgs["video"] == "FLV1" || $pArgs["transport"] == "http" || $pArgs["transport"] == "rtmp" || $pArgs["transport"] == "uit_mmsh") {
			$objResponse->script($lVLCObj->getEmbeddedPlayer());
		} else {
			$objResponse->assign("video1","innerHTML",$lVLCObj->getEmbeddedPlayer());
		}
		return $objResponse;
	}

	function showTVGuide($pChannelID = "") {
		if ($pChannelID == "") return new xajaxResponse();

		$lDreamboxObj = new Dreambox();
		$lChannelInfo = $lDreamboxObj->findBoutiqueWithChannel($pChannelID);
		$lChannelInfo = $lChannelInfo->getChannel($pChannelID);
		$lDreamboxObj->loadProgramGuide($pChannelID,1);
		$lReturnValue = "";
		$lPrevDate = "";
		while ( ($lProgramObj = $lDreamboxObj->programGuide()->getNextProgram()) != false ) {
			if ($lReturnValue == "" || ( date("H",$lPrevDate) < 6 && date("H",$lProgramObj->getStartTime()) > 6) || stripos($lProgramObj->getTitle(),"BIENTOT") !== false ) {
				$lReturnValue .= "<b>" . date("d-m-Y",$lProgramObj->getStartTime()) . "</b>";
			}
			$lPrevDate = $lProgramObj->getStartTime();
			$lReturnValue .= date("H:i",$lProgramObj->getStartTime()) . " - " . date("H:i",$lProgramObj->getStopTime()) . "|<a href=\"javascript:void(0);\" id=\"" . $lProgramObj->getID() . "\" onclick=\"xajax_action('programinfo','" . $lProgramObj->getID() . "')\" title=\"" . $lProgramObj->getDescription() . "\" >" . $lProgramObj->getTitle() . "</a><br />";
		}
		$objResponse = new xajaxResponse();
		$objResponse->assign("tvguide","innerHTML","TVGuide <strong>" . $lChannelInfo->getName() . "</strong>:<br />" . $lReturnValue);
		$objResponse->script("$('#tvguide a').tipsy({gravity: jQuery.fn.tipsy.autoNS, fade: true})");
		return $objResponse;
	}

	function getProgramInfo($pProgramID) {
		$lDreamboxObj = new Dreambox();
		$lDreamboxObj->loadProgramGuide();
		$lProgramObj = $lDreamboxObj->programGuide()->searchProgram($pProgramID);

		$lAjaxResponse = new xajaxResponse();
		$lAjaxResponse->assign("programmaInfo","innerHTML","<strong>" . date("H:i",$lProgramObj->getStartTime()) . " - " . date("H:i",$lProgramObj->getStopTime()) . " | " . $lProgramObj->getTitle() . "</strong><br />" . $lProgramObj->getDescription());
		return $lAjaxResponse;
	}

	function killServer() {
		$lVLCObj = new VLCServer(Settings::getEnigmaVersion(),array(Settings::getDreamboxUserName(),Settings::getDreamboxPassword()));
		$lDebug = $lVLCObj->stopServer();
		$objResponse = new xajaxResponse();
		$objResponse->script("xajax_action('serverstatus',0);");
		return $objResponse;
	}

	function serverStatus($pRepeat = 1) {
		$lVLCObj = new VLCServer();

		$objResponse = new xajaxResponse();
		$objResponse->assign("serverStatus","style.backgroundColor",($lVLCObj->isServerRunning() ? "green" : "red"));
		if ($pRepeat == 1) $objResponse->script("setTimeout('xajax_action(\'serverstatus\')',60000);");
		return $objResponse;
	}

	function getRecordings() {
		$lDreamboxObj = new Dreambox();
		$lDreamboxObj->getRecordings();
		$lReturnValue = "";
		while ($lRecording = $lDreamboxObj->getNextRecording()) {
			$lReturnValue .= "<a href=\"javascript:void(0);\" onclick=\"startRecording('" . Utils::JSSave($lRecording->getFileName()) . "');\">" . date("d/m/Y H:i",$lRecording->getStartTime()) . " - " . $lRecording->getName() . "</a><br />";
		}
		$objResponse = new xajaxResponse();
		$objResponse->assign("tvguide","innerHTML","Recordings:<br />" . $lReturnValue);
		return $objResponse;
	}

	function showToolTip($pProgramID) {
		$lDreamboxObj = new Dreambox();
                $lDreamboxObj->loadProgramGuide();
                $lProgramObj = $lDreamboxObj->programGuide()->searchProgram($pProgramID);

		$objResponse = new xajaxResponse();
		$objResponse->script("jQuery('#" . $pProgramID . "').attr('title','" . $lProgramObj->getDescription() . "');jQuery('#" . $pProgramID . "').tipsy('show');");
		return $objResponse;
	}
?>
