<?php
session_start();

ini_set("error_reporting","E_ALL & ~E_NOTICE & ~E_DEPRECATED");
ini_set("display_errors","0");
ini_set("max_execution_time","300");

// Basic classes with helpers
include_once("Settings.class.php");
include_once("Authorization.inc.php");
include_once("Formats.class.php");
include_once("Utils.class.php");

// Dreambox part
include_once("Dreambox.class.php");
include_once("Boutique.class.php");
include_once("Channel.class.php");
include_once("ProgramGuide.class.php");
include_once("Program.class.php");
include_once("Recording.class.php");

// Server part
include_once("VLCServer.class.php");

// Start the external player
if (isset($_GET["external"]) && !Utils::isMobileDevice()) {
	$lVLCObj = new VLCserver(Settings::getEnigmaVersion());
	$lVLCObj->openExternal($_GET["external"]);
	exit;
}

// Set defaults, first check url, then user default
$lSelectedResolution = ($_GET["resolution"]!= "" ? $_GET["resolution"]              : "512x288");
$lSelectedFPS        = ($_GET["fps"]       != "" ? $_GET["fps"]                     : 25);
$lSelectedBitrate    = ($_GET["bitrate"]   != "" ? $_GET["bitrate"]                 : "500");
$lSelectedVideoCodec = ($_GET["video"]     != "" ? $_GET["video"]                   : "x264");
$lSelectedAudioCodec = ($_GET["audio"]     != "" ? $_GET["audio"]                   : "mp4a");
$lSelectedTransport  = ($_GET["transport"] != "" ? $_GET["transport"]               : "rtmp");
$lSelectedBoutique   = ($_GET["boutiques"] != "" ? $_GET["boutiques"]               : "Canal Digitaal NL");
$lSelectedChannel    = ($_GET["channels"]  != "" ? rawurldecode($_GET["channels"])  : "1:0:1:2711:A:3E8:FFFF0000:0:0:0:"); // NED1

if (Utils::isiPhone() || $_GET["iPhone"]) {
	include_once("index-iPhone.php");
        exit;
}else if (Utils::isMobileDevice() || $_GET["forcemobile"] || $_GET["mobile"]) {
	include_once("index-mobile.php");
	exit;
}

// XAJAX Framework part
include_once("Ajax.class.php");
require("xajax/xajax_core/xajax.inc.php");
$xajax = new xajax();
$xajax->setFlag('debug',Settings::getDebug());
$xajax->configure('javascript URI','xajax');
$xajax->register(XAJAX_FUNCTION,'action');
$xajax->processRequest();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
  <title><?php echo Settings::getProgramName() . " (" . Settings::getVersionNumber() . ")"; ?></title>
  <meta name="generator" content="Bluefish 1.0.7"/>
  <meta name="author" content="Joshua Rubingh"/>
  <meta name="copyright" content="<?php echo date("Y") ?> TheYOSH" />
  <meta name="keywords" content="Restream video from a Dreambox Satelite receiver" />
  <meta name="description" content="Restream video from a Dreambox Satelite receiver" />
  <link rel="shortcut icon" href="favicon.ico" type="image/x-icon" />
  <?php $xajax->printJavascript(); // XAJAX part 2 ?>
  <script language="javascript" type="text/javascript" src="js/jquery-1.4.2.min.js"></script>
  <script language="javascript" type="text/javascript" src="js/jquery-ui-1.7.2.custom.min.js"></script>
  <script language="javascript" type="text/javascript" src="js/jquery.tipsy.js" ></script>
  <script language="javascript" type="text/javascript" src="js/swfobject.js" ></script>
  <script language="javascript" type="text/javascript" src="js/javascript.js" ></script>
  <script language="javascript" type="text/javascript" src="js/silverlight.js" ></script>
  <script language="javascript" type="text/javascript" src="js/wmvplayer.js" ></script>

  <link rel="stylesheet" type="text/css" media="screen" href="css/smoothness/jquery-ui-1.7.2.custom.css" />
  <link rel="stylesheet" type="text/css" media="screen" href="css/tipsy.css" />
  <link rel="stylesheet" type="text/css" media="screen" href="css/style.css" />
</head>
<body id="body">
	<?php include_once("google.inc.php"); ?>
	<h1><?php echo Settings::getProgramName() . " (" . Settings::getVersionNumber() . ")"; ?></h1>
	<p>Here you can watch live television. The channel will be converted to an internetstream in realtime. You can choose from about 2000 channels in about 6 different languages.<br /> Use the pulldown from the 'Boutigue' to change the channelspack. In the pulldown 'Channel' you can choose the channel to watch. Finaly press the button 'Change'. Wait for about 5 seconds and the player should start.</p>
	<p>If the stream doesn't start, or the image is black, than you have probably choosen a channel which I don't have access to. So change to an other channel. You should also have Video Lan Client installed as active plugin for Firefox.</p>
	<p>Flash can take up some more time. Wait for about 30 sec for flash starts playing</p>
	<form id="zapForm" name="zapForm">
		<table align="center" id="mainTable" border="1">
		<tr>
			<td align="center" valign="middle" width="400" height="400">
				<!-- Player -->
				<div id="video1" >&nbsp;</div>
				<table width="100%" border="1">
                                <tr>
                                        <td>Resolution:<br /><?php echo Utils::makePulldown("resolution",Formats::getDimensions(),$lSelectedResolution) ?></td>
                                        <td>FPS:<br /><?php echo Utils::makePulldown("fps",Formats::getFrameRates(),$lSelectedFPS) ?></td>
                                        <td>Bitrate:<br /><?php echo Utils::makePulldown("bitrate",Formats::getVideoBitrates(),$lSelectedBitrate) ?></td>
                                        <td>Video codec:<br /><?php echo Utils::makePulldown("video",Formats::getVideoCodecs(),$lSelectedVideoCodec) ?></td>
                                        <td>Audio codec:<br /><?php echo Utils::makePulldown("audio",Formats::getAudioCodecs(),$lSelectedAudioCodec) ?></td>
                                        <td>Transport:<br /><?php echo Utils::makePulldown("transport",Formats::getStreamTypes(),$lSelectedTransport) ?></td>
                                </tr>
                                <tr>
                                        <td colspan="2">Boutigue: <br /><div id="boutiquesSelector"><select name="boutiques" id="boutiques" onchange="xajax_action('loadChannels',this.value)"><option value="-1">Loading boutiques...</option></select></div></td>
                                        <td colspan="2">Channel:<br /><div id="channelsSelector"><select name="channels" id="channels" onchange="xajax_action('tvguide',this.value);"><option value="-1">Loading channels...</option></select></div></td>
                                        <td><br /><input type="button" value="Change Channel" onclick="showZapWating();xajax_action('stop','');xajax_action('zap',xajax.getFormValues('zapForm'))"></td>
					<td><br /><input type="button" value="Kill server" onclick="xajax_action('killserver')"></td>
                                </tr>
				<tr>
					<td colspan="3"><a href="javascript:void(0)" onclick="openExternal();">Open in external player</a></td>
                                        <td colspan="3"><a href="javascript:void(0)" onclick="xajax_action('loadRecordings');">Load recordings</a></td>

				</tr>
                                </table>
			</td>
			<td rowspan="5">
				<!-- tv guide -->
				<div id="tvguide">&nbsp;</div>
			</td>
		</tr>
		<tr>
			<td id="serverStatus">Server status</td>
		</tr>
		<tr>
			<td>Programma info:
				<div id="programmaInfo">&nbsp;</div>
			</td>
		</tr>
		</table>
	</form>
	<p>
		<strong>Supported players:</strong> <a href="javascript:void(0);" onclick="togglePlayersTable()" id="playerToggle" >Show</a><br />
		<table id="matrix" class="playersTabel">
			<tr>
				<th></th>
				<th>VLC</th>
				<th>Windows Media</th>
				<th>Flash (v. 9.0 r124)</th>
			</tr>
			<tr>
				<td>Resolution</td>
				<td>any</td>
				<td>any</td>
				<td>any</td>
			</tr>
			<tr>
				<td>FPS</td>
				<td>any</td>
				<td>any</td>
				<td>any</td>
			</tr>
			<tr>
				<td>Bitrate</td>
				<td>any</td>
				<td>any</td>
				<td>any</td>
			</tr>
			<tr>
				<td>Video codec</td>
				<td>DIV3, MP43, H263</td>
				<td>WMV1, WMV2</td>
				<td>x264</td>
			</tr>
			<tr>
				<td>Audio codec</td>
				<td>mpga, mp3</td>
				<td>mp3</td>
				<td>mp4a</td>
			</tr>
			<tr>
				<td>Transport</td>
				<td>http, rtp</td>
				<td>mms</td>
				<td>rtmp</td>
			</tr>
			<tr>
				<td>Boutique</td>
				<td>any</td>
				<td>any</td>
				<td>any</td>
			</tr>
			<tr>
				<td>Channel</td>
				<td>any</td>
				<td>any</td>
				<td>any</td>
			</tr>
		</table>
	</p>


	<div id="dialog"><p>Please wait while we are loading the boutiques and channel data...<br /><br />Loading...<img src="images/loadingAnimation.gif" alt="Loading" align="center" /></p></div>
	<div id="zapWaitingMessage"><p>Please wait while we are changing the channel...<br /><br />Zapping...<img src="images/loadingAnimation.gif" alt="Loading" align="center" /></p></div>
	<?php if (Settings::getDebug()) { ?>
	<div id="debug"><a href="javascript:void(0);" onclick="toggleDebug()">Debug..</a>
		<div id="debug-content">
			<?php
				$lVLCobj = new VLCServer();
				$lVLCobj->getCurrentStream();
			?>
		</div>
	</div>
	<?php } ?>
</body>
</html>
